#!/bin/sh
UPDATEDDAMODE=${TEMP_FOLDER}/upgrade_dda_asyn_mode.sql
ROLLBACKDDAMODE=${TEMP_FOLDER}/rollback_dda_asyn_mode.sql
TAG_ROLLBACKDBSCHEMA=${PATCH_FOLDER}/tag_rollback_dda_schema
UpdateDLPTemplateSql=${TEMP_FOLDER}/UpdateDlp2Template31_en.sql
UpdateDLPTemplateSqlFrom01to05=${TEMP_FOLDER}/UpdateDlpTemplate31From01to05_en.sql
UpdateDLPTemplateSqlFrom05to06=${TEMP_FOLDER}/UpdateDlpTemplate31From05to06_en.sql
UpdateDLPXmlForImssd=${TEMP_FOLDER}/UpdateDlpTemplate.sh
F_install()
{
    #SEGTT-293119, because import may also override the data.
    expireTime=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select value  from tb_global_setting where name='db_pool_param';" imss|awk 'NR==3 {print $0}'|awk -F ";" '{print $4}'`
    if [ $expireTime -eq 10000 ]; then
        echo "expireTime is 10seconds, changing to 1 hour"
        /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "update tb_global_setting set value = split_part(value,';',1) ||';'||split_part(value,';',2)||';'||split_part(value,';',3)||';3600000' where name = 'ldap_auth_pool_param';" imss
        /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "update tb_global_setting set value = split_part(value,';',1) ||';'||split_part(value,';',2)||';'||split_part(value,';',3)||';3600000' where name = 'db_pool_param';" imss
        /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "update tb_global_setting set value = split_part(value,';',1) ||';'||split_part(value,';',2)||';'||split_part(value,';',3)||';3600000' where name = 'ldap_oper_pool_param';" imss
    else
       echo "expireTime is $expireTime , DO not need to update it"

    fi
    #SEGTT-
    /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "insert into tb_global_setting values ('wrsagent','tmufe_alter_rs_host','backup35.url.trendmicro.com','imss.ini');" imss
   #SEGTT-328669
   /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "update tb_global_setting  set value='77,80,81,79,82,83,86,78,84,75,73,39,85,76,74,88,91,92,93,95' where name='InternetSecurity' and section='wrs';" imss 
    return 0
}

F_UpdateDBschema()
{
    #SEGTT-314211
    echo "Checking if need to upgrade db schema"
    /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select last_error from tb_dtas_mail limit 1" imss
    if [ $? -ne 0 ]; then
       #check if submit_target exists but last_error doesnot exists.
       /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select submit_target from tb_dtas_mail limit 1" imss
       if [ $? -eq 0 ]; then
           echo "submit_target exists before, submit_target must after last_error"
           /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "alter table tb_dtas_mail drop column submit_target" imss
           if [ $? -eq 0 ]; then
              echo "drop column submit_target first"
           else
              echo "column submit_target exists and cannot be dropped"
              return 1
           fi
       fi
       echo "Updating db schema for DDA asyn integration mode "
       dbFail=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -f ${UPDATEDDAMODE} imss|grep "ROLLBACK" |grep -v grep|wc -l`
       if [ $dbFail -eq 0 ];then
           touch ${TAG_ROLLBACKDBSCHEMA}
       else 
          return 1
       fi
    else
       rm -rf ${TAG_ROLLBACKDBSCHEMA}
    fi  
    
    
    echo "Checking if need to upgrade for multi-DDA"
    /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select submit_target from tb_dtas_mail limit 1" imss
    if [ $? -ne 0 ]; then
        echo "Updating db schema for multi-DDA "
        /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "ALTER TABLE tb_dtas_mail ADD COLUMN submit_target VARCHAR(256) DEFAULT ''" imss
        if [ $? -ne 0 ]; then
           echo "Updating db schema for multi-DDA  failed"
           return 1
        fi
    fi
    
    echo "Checking if need to upgrade dlp template3.1.1001"
    #/opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select value from tb_global_setting where name='dlp_template_version' and section='general';" imss
    neeedUpgradeTemplatefrom1001to1005=0
	neeedUpgradeTemplatefrom1005to1006=0
    dlp_template_version=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -c "select value  from tb_global_setting where name='dlp_template_version';" imss|grep -v "row" |awk 'NR==3 {print $0}'`  
    if [ ${dlp_template_version}x == ""x ]; then
       echo "DLP template is 3.0. Need to upgrade dlp template to 3.1.1001 firstly"
       dbDlpFail=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -f ${UpdateDLPTemplateSql} imss|grep "ROLLBACK" |grep -v grep|wc -l`
        if [ $dbDlpFail -eq 0 ];then
           echo "upgrade dlp template to 3.1.1001 succeed. try to upgrade to 3.1.1005"
           #update the xml that used for imssd
            UpdateDLPComplianceTemplateFullXML=1
            neeedUpgradeTemplatefrom1001to1005=1
            neeedUpgradeTemplatefrom1005to1006=1
        else 
          return 1
        fi
    fi
    if [ ${dlp_template_version}x == "3.1.1001"x -o $neeedUpgradeTemplatefrom1001to1005 -eq 1 ]; then
         echo "Trying to upgrade template from 1001 to 1005"
         dbDlpFail=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -f ${UpdateDLPTemplateSqlFrom01to05} imss|grep "ROLLBACK" |grep -v grep|wc -l`
         if [ $dbDlpFail -eq 0 ];then
             echo "upgrade dlp template to 3.1.1005 succeed."
             UpdateDLPComplianceTemplateFullXML=1
             neeedUpgradeTemplatefrom1005to1006=1
         else 
             return 1
         fi 
    fi  
    if [ ${dlp_template_version}x == "3.1.1005"x -o  $neeedUpgradeTemplatefrom1005to1006 -eq 1 ]; then
        echo "Trying to upgrade dlp template to 3.1.1006 ...."
        dbDlpFail=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -f ${UpdateDLPTemplateSqlFrom05to06} imss|grep "ROLLBACK" |grep -v grep|wc -l`
        if [ $dbDlpFail -eq 0 ];then
            echo "upgrade dlp template to 3.1.1006 succeed."
            UpdateDLPComplianceTemplateFullXML=1
        else 
            return 1
        fi 
    else 
        echo "No need to upgrade DLP template"	
    fi    
}        
F_rollback()
{        
    #SEGTT-293119
    #NO need to rollback
    return 0
}

F_RollbackDBschema()
{
    #SEGTT-314211
    echo "Checking if need to rollback db schema"
    if [ -e ${TAG_ROLLBACKDBSCHEMA} ] ; then
       echo "rollback db schema for DDA asyn integration mode "
       dbFail=`/opt/trend/imss/PostgreSQL/bin/psql -U sa -f ${ROLLBACKDDAMODE} imss|grep "ROLLBACK" |grep -v grep|wc -l`
       if [ $dbFail -eq 0 ];then
          rm -rf ${TAG_ROLLBACKDBSCHEMA}
          #if roll back ddamode, must rollback  multi-DDA, otherwise manager cannot import logs.
           /opt/trend/imss/PostgreSQL/bin/psql -U sa -c "alter table tb_dtas_mail drop column submit_target" imss
       else
          return 1
       fi
    fi 
}

case "$1" in
'install')
    F_install
    ;;
 'updatedbschema')
    F_UpdateDBschema
    ;;
'rollback')
    F_rollback
    ;;
 'rollbackdbschema')
     F_RollbackDBschema
     ;;
*)
    exit 0
    ;;
esac

