---using transaction to protect current database
BEGIN;

------------------------------------------------
-- script begins from here

--rollback tables
--create.sql, rollback table tb_dtas_mail
alter table tb_dtas_mail drop column last_error;
alter table tb_dtas_mail drop column xml_report_uuid;
 
--rollback functions
---rpt_GenHourlyPolicySumSP.sql
CREATE OR REPLACE FUNCTION GenHourlyPolicySum(int, timestamptz, timestamptz) RETURNS integer AS '
DECLARE
    msg_cnt_total    INTEGER;
    msg_cnt_in       INTEGER;
    msg_cnt_out      INTEGER;
    msg_size_total   float;
    msg_size_in      float;
    msg_size_out     float;
    virus_total      INTEGER;
    virus_incoming   INTEGER;
    virus_outgoing   INTEGER;
    spy_total        INTEGER;
    spy_incoming     INTEGER;
    spy_outgoing     INTEGER;
    spam_total       INTEGER;
    spam_incoming    INTEGER;
    spam_outgoing    INTEGER;
    phish_total      INTEGER;
    phish_incoming   INTEGER;
    phish_outgoing   INTEGER;
    wrs_total        INTEGER;
    wrs_incoming     INTEGER;
    wrs_outgoing     INTEGER;
    dkim_total       INTEGER;
    dkim_incoming    INTEGER;
    dkim_outgoing    INTEGER;
    attach_total     INTEGER;
    attach_incoming  INTEGER;
    attach_outgoing  INTEGER;
    size_total       INTEGER;
    size_incoming    INTEGER;
    size_outgoing    INTEGER;
    content_total    INTEGER;
    content_incoming INTEGER;
    content_outgoing INTEGER;
    other_total      INTEGER;
    other_incoming   INTEGER;
    other_outgoing   INTEGER;
    except_total     INTEGER;
    except_incoming  INTEGER;
    except_outgoing  INTEGER;
    clean_total      INTEGER;
    clean_incoming   INTEGER;
    clean_outgoing   INTEGER;
    preflt_total     INTEGER;
    preflt_incoming  INTEGER;
    preflt_outgoing  INTEGER;
    compliance_total INTEGER;
    compliance_incoming INTEGER;
    compliance_outgoing INTEGER;
     ibe_total INTEGER;
    ibe_incoming INTEGER;
    ibe_outgoing INTEGER;
    cnt_ipprof_conn  INTEGER;
    cnt_ipprof_block INTEGER;
    cnt_virus        INTEGER;
    cnt_spam         INTEGER;
    cnt_bounce       INTEGER;
    cnt_dha          INTEGER;
    cnt_manual       INTEGER;
    cnt_nrs_conn     INTEGER;
    cnt_nrs_block    INTEGER;
    spamact_quar     INTEGER;
    spamact_del      INTEGER;
    spamact_subtag   INTEGER;
    spamact_other    INTEGER;
    spamact_total_size  float;
    spamact_quar_size   float;
    spamact_del_size    float;
    spamact_subtag_size float;
    spamact_other_size  float;
    virusact_del     INTEGER;
    virusact_quar    INTEGER;
    virusact_clean   INTEGER;
    virusact_attdel  INTEGER; 
    decryption_total   INTEGER;
    encryption_total   INTEGER;  
    decryption_size   float;
    encryption_size   float;
    rec_count        RECORD;
    table_id         ALIAS FOR $1;
    v_starttime      ALIAS FOR $2;
    v_endtime        ALIAS FOR $3;
    v_tmp            timestamptz;
    dda_total        INTEGER;
    dda_incoming     INTEGER;
    dda_outgoing     INTEGER;    
    ddava_no         INTEGER;
    ddava_low        INTEGER;
    ddava_med        INTEGER;
    ddava_high       INTEGER;
    ddava_err        INTEGER;
    ddava_wait       INTEGER;
    suspicious_total INTEGER;
    suspicious_incoming INTEGER;
    suspicious_outgoing INTEGER;
    ccca_total       INTEGER;
    ccca_incoming    INTEGER;
    ccca_outgoing    INTEGER;
    graymail_total      INTEGER;
    graymail_incoming   INTEGER;
    graymail_outgoing   INTEGER;
    graymail_cat_mml    INTEGER;
    graymail_cat_scl    INTEGER;
    graymail_cat_oth    INTEGER;
    sqlcmd           text;
    analyzed_apt_total INTEGER;
    analyzed_apt_incoming INTEGER;
    analyzed_apt_outgoing INTEGER;    
BEGIN
    msg_cnt_total    := 0;
    msg_cnt_in       := 0;
    msg_cnt_out      := 0;
    msg_size_total   := 0;
    msg_size_in      := 0;
    msg_size_out     := 0;
    virus_total      := 0;
    virus_incoming   := 0;
    virus_outgoing   := 0;
    spy_total        := 0;
    spy_incoming     := 0;
    spy_outgoing     := 0;
    spam_total       := 0;
    spam_incoming    := 0;
    spam_outgoing    := 0;
    phish_total      := 0;
    phish_incoming   := 0;
    phish_outgoing   := 0;
    wrs_total        := 0;
    wrs_incoming     := 0;
    wrs_outgoing     := 0;
    dkim_total       := 0;
    dkim_incoming    := 0;
    dkim_outgoing    := 0;
    attach_total     := 0;
    attach_incoming  := 0;
    attach_outgoing  := 0;
    size_total       := 0;
    size_incoming    := 0;
    size_outgoing    := 0;
    content_total    := 0;
    content_incoming := 0;
    content_outgoing := 0;
    other_total      := 0;
    other_incoming   := 0;
    other_outgoing   := 0;
    except_total     := 0;
    except_incoming  := 0;
    except_outgoing  := 0;
    clean_total      := 0;
    clean_incoming   := 0;
    clean_outgoing   := 0;
    preflt_total     := 0;
    preflt_incoming  := 0;
    preflt_outgoing  := 0;
    compliance_total := 0;
    compliance_incoming  := 0;
    compliance_outgoing  := 0;
    ibe_total := 0;
    ibe_incoming  := 0;
    ibe_outgoing  := 0;
    spamact_quar     := 0;
    spamact_del      := 0;
    spamact_subtag   := 0;
    spamact_other    := 0;
    spamact_total_size  := 0;
    spamact_quar_size   := 0;
    spamact_del_size    := 0;
    spamact_subtag_size := 0;
    spamact_other_size  := 0;
    virusact_del     := 0;
    virusact_quar    := 0;
    virusact_clean   := 0;
    virusact_attdel  := 0; 
    decryption_total    := 0;
    encryption_total    := 0; 
    decryption_size   := 0;
    encryption_size    := 0; 
    dda_total := 0;
    dda_incoming := 0;
    dda_outgoing := 0;
    ddava_no    := 0;
    ddava_low   := 0;
    ddava_med   := 0;
    ddava_high  := 0;
    ddava_err   := 0;
    ddava_wait  := 0;
    suspicious_total := 0;
    suspicious_incoming := 0;
    suspicious_outgoing := 0;
    analyzed_apt_total := 0;
    analyzed_apt_incoming := 0;
    analyzed_apt_outgoing := 0;    
    ccca_total        := 0;
    ccca_incoming     := 0;
    ccca_outgoing     := 0;
    graymail_total      := 0;
    graymail_incoming   := 0;
    graymail_outgoing   := 0;
    graymail_cat_mml    := 0;
    graymail_cat_scl    := 0;
    graymail_cat_oth    := 0;
    
    sqlcmd := ''select msg_route, count(*) as cnt, sum(msg_size) as sum,
            sum(filter_type_virus) as virus, sum(filter_type_spyware) as spyware,
            sum(filter_type_spam) as spam, sum(filter_type_phishing) as phishing, sum(filter_type_wrs) as wrs, 
            sum(filter_type_dkim) as dkim,
            sum(filter_type_attachment) as attachment, sum(filter_type_size) as size,
            sum(filter_type_content) as content, sum(filter_type_other) as other,
            sum(filter_type_except) as exception_cnt, sum(filter_type_clean) as clean, 
            sum(filter_type_preflt) as preflt, sum(filter_type_compliance) as compliance,
            sum(filter_type_suspicious) as suspicious, sum(filter_type_dda) as dda,
            sum(act_ibe) as ibe,
            sum(spamact_quar) as sa_quar, sum(spamact_del) as sa_del,
            sum(spamact_subtag) as sa_subtag, sum(spamact_other) as sa_other,
            sum(filter_type_spam*msg_size) as sa_total_size,
            sum(spamact_quar*msg_size) as sa_quar_size, sum(spamact_del*msg_size) as sa_del_size,
            sum(spamact_subtag*msg_size) as sa_subtag_size, sum(spamact_other*msg_size) as sa_other_size,
            sum(virusact_del) as va_del, sum(virusact_quar) as va_quar,
            sum(virusact_clean) as va_clean, sum(virusact_attdel) as va_attdel,
            sum(suspicious_no) as dtas_no, sum(suspicious_low) as dtas_low, sum(suspicious_med) as dtas_med,
            sum(suspicious_high) as dtas_high, sum(suspicious_err) as dtas_err, sum(suspicious_wait) as dtas_wait,
            sum(act_dec) as dec, sum(act_enc) as enc ,
            sum(act_dec*msg_size) as dec_size, sum(act_enc*msg_size) as enc_size, sum(filter_type_ccca) as ccca,
            sum(filter_type_graymail) as graymail,
            sum(graymail_cat_mml) as graymail_mml, sum(graymail_cat_scl) as graymail_scl, sum(graymail_cat_oth) as graymail_oth,
            sum(filter_type_analyzed_apt) as analyzed_apt
            from
            (
            select
            case when sum(pe.filter_type_virus::integer) >0 then 1 else 0 end       as filter_type_virus,
            case when sum(pe.filter_type_spyware::integer) >0 then 1 else 0 end     as filter_type_spyware,
            case when sum(case when pe.suspicious_apt_filters_map<>0 then 1 else 0 end) >0 then 1 else 0 end     as filter_type_suspicious,
            case when sum(case when pe.analyzed_apt_filters_map<>0 then 1 else 0 end) >0 then 1 else 0 end     as filter_type_analyzed_apt,
            case when sum((pe.dda_status>0 and pe.dda_status<32765)::integer) >0 then 1 else 0 end   as filter_type_dda,
            case when sum(pe.filter_type_spam::integer) >0 then 1 else 0 end        as filter_type_spam,
            case when sum(pe.filter_type_phishing::integer) >0 then 1 else 0 end    as filter_type_phishing,
            case when sum(pe.filter_type_wrs::integer) >0 then 1 else 0 end         as filter_type_wrs,
            case when sum(pe.filter_type_dkim::integer) >0 then 1 else 0 end        as filter_type_dkim,
            case when sum(pe.filter_type_attachment::integer) >0 then 1 else 0 end  as filter_type_attachment,
            case when sum(pe.filter_type_size::integer) >0 then 1 else 0 end        as filter_type_size,
            case when sum(pe.filter_type_content::integer) >0 then 1 else 0 end     as filter_type_content,
            case when sum(pe.filter_type_other::integer) >0 then 1 else 0 end       as filter_type_other,
            case when sum((pe.filter_type_malformed|pe.filter_type_unscanned)::integer) >0 then 1 else 0 end   as filter_type_except,
            case when sum(
                         (pe.filter_type_virus|pe.filter_type_spyware|pe.filter_type_spam|pe.filter_type_phishing|pe.filter_type_wrs|pe.filter_type_dkim|pe.filter_type_attachment|pe.filter_type_size|pe.filter_type_content|pe.filter_type_other|pe.filter_type_malformed|pe.filter_type_unscanned|pe.filter_type_preflt|pe.filter_type_compliance|pe.filter_type_ccca|pe.filter_type_graymail|pe.filter_type_snap)::integer                       
                         + case when pe.suspicious_apt_filters_map<>0 then 1 else 0 end
                         + case when pe.analyzed_apt_filters_map<>0 then 1 else 0 end) 
                         >0 then 0 else 1 end as filter_type_clean,
            case when sum(pe.filter_type_preflt::integer) >0 then 1 else 0 end      as filter_type_preflt,
            case when sum(pe.filter_type_compliance::integer) >0 then 1 else 0 end      as filter_type_compliance,
            case when sum((pe.act_decryption|pe.act_encryption|pe.act_reencryption)::integer) >0 then 1 else 0 end      as act_ibe,
            case when sum((pe.filter_type_spam&pe.act_quarantined)::integer) >0 then 1 else 0 end              as spamact_quar,
            case when sum((pe.filter_type_spam&pe.act_deleted)::integer) >0 then 1 else 0 end                  as spamact_del,
            case when sum((pe.filter_type_spam&pe.act_subjects_tagged)::integer) >0 then 1 else 0 end          as spamact_subtag,
            case when sum((pe.filter_type_spam&(((~pe.act_quarantined)&(~pe.act_deleted)&(~pe.act_subjects_tagged))|pe.act_delivered|pe.act_archived|pe.act_rcptchanged|pe.act_stamped|pe.act_attachments_deleted|pe.act_delivery_postponed|pe.act_notifications_sent|pe.act_cleaned|pe.act_bcc|pe.act_handoff|pe.act_insert_x_header_tag))::integer) >0 then 1 else 0 end          as spamact_other,
            case when sum((pe.filter_type_virus&pe.act_deleted)::integer) >0 then 1 else 0 end                 as virusact_del,            
            case when sum((pe.filter_type_virus&pe.act_quarantined)::integer) >0 then 1 else 0 end             as virusact_quar,
            case when sum((pe.filter_type_virus&pe.act_cleaned)::integer) >0 then 1 else 0 end                 as virusact_clean,
            case when sum((pe.filter_type_virus&pe.act_attachments_deleted)::integer) >0 then 1 else 0 end     as virusact_attdel,
            case when sum((pe.dda_rating=0)::integer) >0 then 1 else 0 end        as suspicious_no,
            case when sum((pe.dda_rating=1)::integer) >0 then 1 else 0 end        as suspicious_low,
            case when sum((pe.dda_rating=2)::integer) >0 then 1 else 0 end        as suspicious_med,
            case when sum((pe.dda_rating=3)::integer) >0 then 1 else 0 end        as suspicious_high,
            case when sum((pe.dda_rating<0 or (pe.dda_rating>3 and pe.dda_rating<32765) 
                         or pe.dda_status=2 or pe.dda_status=4 or pe.dda_status=11)::integer) >0 then 1 else 0 end        as suspicious_err,
            case when sum((pe.dda_status=1 or pe.dda_status=3)::integer) >0 then 1 else 0 end        as suspicious_wait,
            case when sum(pe.act_decryption::integer) >0 then 1 else 0      end          as act_dec,
            case when sum((pe.act_encryption|pe.act_reencryption)::integer) >0 then 1 else 0      end         as act_enc,
            case when sum(pe.filter_type_ccca::integer) >0 then 1 else 0 end    as filter_type_ccca,
            case when sum(pe.filter_type_graymail::integer) >0 then 1 else 0 end    as filter_type_graymail,
            case when sum((pe.filter_type_graymail=''''1'''' and pe.graymail_category=1)::integer) >0 then 1 else 0 end        as graymail_cat_mml,
            case when sum((pe.filter_type_graymail=''''1'''' and pe.graymail_category=2)::integer) >0 then 1 else 0 end        as graymail_cat_scl,
            case when sum((pe.filter_type_graymail=''''1'''' and pe.graymail_category=0)::integer) >0 then 1 else 0 end        as graymail_cat_oth,
            msg_id                                                                  as msg_id,
            scanner_id                                                              as scanner_id,
            msg_route                                                               as msg_route,
            max(msg_size)                                                           as msg_size
            from tb_policy_event_'' || table_id || '' pe where pe.dda_status<>100 
            group by msg_id, scanner_id, msg_route
            ) as foo group by msg_route'';
    for rec_count in execute sqlcmd
    loop
        if rec_count.msg_route = 1 then
            msg_cnt_in := rec_count.cnt;
            msg_size_in := rec_count.sum;
            virus_incoming := rec_count.virus;
            spy_incoming := rec_count.spyware;
            spam_incoming := rec_count.spam;
            phish_incoming := rec_count.phishing;
            wrs_incoming := rec_count.wrs;
            dkim_incoming := rec_count.dkim;
            attach_incoming := rec_count.attachment;
            size_incoming := rec_count.size;
            content_incoming := rec_count.content;
            other_incoming := rec_count.other;
            except_incoming := rec_count.exception_cnt;
            clean_incoming := rec_count.clean;
            preflt_incoming := rec_count.preflt;
            compliance_incoming := rec_count.compliance;
            ibe_incoming := rec_count.ibe;
            dda_incoming := rec_count.dda;
            suspicious_incoming := rec_count.suspicious;
            ccca_incoming := rec_count.ccca;
            graymail_incoming := rec_count.graymail;
            analyzed_apt_incoming := rec_count.analyzed_apt;
        else
            if rec_count.msg_route = 2 then
                msg_cnt_out := rec_count.cnt;
                msg_size_out := rec_count.sum;
                virus_outgoing := rec_count.virus;
                spy_outgoing := rec_count.spyware;
                spam_outgoing := rec_count.spam;
                phish_outgoing := rec_count.phishing;
                wrs_outgoing := rec_count.wrs;
                dkim_outgoing := rec_count.dkim;
                attach_outgoing := rec_count.attachment;
                size_outgoing := rec_count.size;
                content_outgoing := rec_count.content;
                other_outgoing := rec_count.other;
                except_outgoing := rec_count.exception_cnt;
                clean_outgoing := rec_count.clean;
                preflt_outgoing := rec_count.preflt;
                compliance_outgoing := rec_count.compliance;
                ibe_outgoing := rec_count.ibe;
                dda_outgoing := rec_count.dda;
                suspicious_outgoing := rec_count.suspicious;
                ccca_outgoing := rec_count.ccca;
                graymail_outgoing := rec_count.graymail;
                analyzed_apt_outgoing := rec_count.analyzed_apt;
            end if;
        end if;
        msg_cnt_total := msg_cnt_total + rec_count.cnt;
        msg_size_total := msg_size_total + rec_count.sum;     
        virus_total := virus_total + rec_count.virus;
        spy_total := spy_total + rec_count.spyware;
        spam_total := spam_total + rec_count.spam;
        phish_total := phish_total + rec_count.phishing;
        wrs_total := wrs_total + rec_count.wrs;
        dkim_total := dkim_total + rec_count.dkim;
        attach_total := attach_total + rec_count.attachment;
        size_total := size_total + rec_count.size;
        content_total := content_total + rec_count.content;
        other_total := other_total + rec_count.other;
        except_total := except_total + rec_count.exception_cnt;
        clean_total := clean_total + rec_count.clean;
        preflt_total := preflt_total + rec_count.preflt;
        compliance_total := compliance_total + rec_count.compliance;
        ibe_total := ibe_total + rec_count.ibe;
        spamact_quar := spamact_quar + rec_count.sa_quar;
        spamact_del := spamact_del + rec_count.sa_del;
        spamact_subtag := spamact_subtag + rec_count.sa_subtag;
        spamact_other := spamact_other + rec_count.sa_other;
        spamact_total_size := spamact_total_size + rec_count.sa_total_size;
        spamact_quar_size := spamact_quar_size + rec_count.sa_quar_size;
        spamact_del_size := spamact_del_size + rec_count.sa_del_size;
        spamact_subtag_size := spamact_subtag_size + rec_count.sa_subtag_size;
        spamact_other_size := spamact_other_size + rec_count.sa_other_size;
        virusact_del := virusact_del + rec_count.va_del;
        virusact_quar := virusact_quar + rec_count.va_quar;
        virusact_clean := virusact_clean + rec_count.va_clean;
        virusact_attdel := virusact_attdel + rec_count.va_attdel;
        decryption_total	  := decryption_total + rec_count.dec;
        encryption_total	  := encryption_total + rec_count.enc;
        decryption_size :=decryption_size + rec_count.dec_size;
        encryption_size :=encryption_size + rec_count.enc_size;
        dda_total := dda_total + rec_count.dda;
        ddava_no := ddava_no + rec_count.dtas_no;
        ddava_low := ddava_low + rec_count.dtas_low;
        ddava_med := ddava_med + rec_count.dtas_med;
        ddava_high := ddava_high + rec_count.dtas_high;
        ddava_err := ddava_err + rec_count.dtas_err;
        ddava_wait := ddava_wait + rec_count.dtas_wait;
        suspicious_total := suspicious_total + rec_count.suspicious;
        ccca_total :=ccca_total + rec_count.ccca;
        graymail_total := graymail_total + rec_count.graymail;
        graymail_cat_mml := graymail_cat_mml + rec_count.graymail_mml;
        graymail_cat_scl := graymail_cat_scl + rec_count.graymail_scl;
        graymail_cat_oth := graymail_cat_oth + rec_count.graymail_oth;
        analyzed_apt_total := analyzed_apt_total + rec_count.analyzed_apt;
    end loop;

    cnt_ipprof_conn  := 0;
    cnt_ipprof_block := 0;
    cnt_virus        := 0;
    cnt_spam         := 0;
    cnt_bounce       := 0;
    cnt_dha          := 0;
    cnt_manual       := 0;
    
    select into cnt_ipprof_conn count(*) from t_cachedip where time >= v_starttime and time < v_endtime;
    
    for rec_count in
        select type, sum(count) as cnt from t_blockedip where createtime >= v_starttime and createtime < v_endtime group by type
    loop
        if rec_count.type = 1 then
            cnt_dha := rec_count.cnt;
        end if;
        if rec_count.type = 2 then
            cnt_virus := rec_count.cnt;
        end if;
        if rec_count.type = 3 then
            cnt_spam := rec_count.cnt;
        end if;
        if rec_count.type = 4 then
            cnt_bounce := rec_count.cnt;
        end if;
        if rec_count.type = 5 then
            cnt_manual := rec_count.cnt;
        end if;
        cnt_ipprof_block := cnt_ipprof_block + rec_count.cnt;
    end loop;

    cnt_nrs_conn  := 0;
    cnt_nrs_block := 0;
    for rec_count in
        select action, sum(act_num) as cnt from tb_ip_event where time_date >= v_starttime and time_date < v_endtime group by action
    loop
        if rec_count.action = 0 then
            cnt_nrs_conn := rec_count.cnt;
        else
            if rec_count.action = 1 then
                cnt_nrs_block := rec_count.cnt;
            end if;
        end if;
    end loop;
    cnt_ipprof_conn := cnt_ipprof_conn + cnt_nrs_block;
    
    select into v_tmp starttime from tb_traffic_summary where starttime = v_starttime;
    if found then
       update tb_traffic_summary set starttime=v_starttime, endtime=v_endtime,
       msg_total=msg_cnt_total, msg_in=msg_cnt_in, msg_out=msg_cnt_out,
       msg_total_size=msg_size_total, msg_in_size=msg_size_in, msg_out_size=msg_size_out,
       pol_virus_total=virus_total, pol_virus_in=virus_incoming, pol_virus_out=virus_outgoing,
       pol_spyware_total=spy_total, pol_spyware_in=spy_incoming, pol_spyware_out=spy_outgoing,
       pol_spam_total=spam_total, pol_spam_in=spam_incoming, pol_spam_out=spam_outgoing,
       pol_phish_total=phish_total, pol_phish_in=phish_incoming, pol_phish_out=phish_outgoing,
       pol_wrs_total=wrs_total, pol_wrs_in=wrs_incoming, pol_wrs_out=wrs_outgoing,
       pol_dkim_total=dkim_total, pol_dkim_in=dkim_incoming, pol_dkim_out=dkim_outgoing,
       pol_attach_total=attach_total, pol_attach_in=attach_incoming, pol_attach_out=attach_outgoing,
       pol_size_total=size_total, pol_size_in=size_incoming, pol_size_out=size_outgoing,
       pol_content_total=content_total, pol_content_in=content_incoming, pol_content_out=content_outgoing,
       pol_other_total=other_total, pol_other_in=other_incoming, pol_other_out=other_outgoing,
       pol_exception_total=except_total, pol_exception_in=except_incoming, pol_exception_out=except_outgoing,
       pol_ipfilt_total=cnt_ipprof_block, pol_ipfilt_in=cnt_ipprof_block, pol_ipfilt_out=0,
       pol_nrs_total=cnt_nrs_block, pol_nrs_in=cnt_nrs_block, pol_nrs_out=0,
       ipfilt_conn=cnt_ipprof_conn, ipfilt_block=cnt_ipprof_block, ipfilt_virus=cnt_virus, ipfilt_spam=cnt_spam,
       ipfilt_bounce=cnt_bounce, ipfilt_dha=cnt_dha, ipfilt_manual=cnt_manual,
       nrs_conn=cnt_nrs_conn, nrs_block=cnt_nrs_block,
       spam_quar=spamact_quar, spam_del=spamact_del, spam_subtag=spamact_subtag, spam_other=spamact_other, spam_total_size=spamact_total_size,
       spam_quar_size=spamact_quar_size, spam_del_size=spamact_del_size, spam_subtag_size=spamact_subtag_size, spam_other_size=spamact_other_size,
       virus_del=virusact_del, virus_quar=virusact_quar, virus_clean=virusact_clean, virus_attdel=virusact_attdel,
       msg_clean_total=clean_total, msg_clean_in=clean_incoming, msg_clean_out=clean_outgoing,
       pol_preflt_total=preflt_total, pol_preflt_in=preflt_incoming, pol_preflt_out=preflt_outgoing,
       pol_compliance_total=compliance_total, pol_compliance_in=compliance_incoming, pol_compliance_out=compliance_outgoing,
       pol_dec_total=decryption_total, pol_enc_total=encryption_total ,pol_dec_size=decryption_size, pol_enc_size=encryption_size,
       pol_ibe_total=ibe_total, pol_ibe_in=ibe_incoming, pol_ibe_out=ibe_outgoing,
       pol_dda_total=dda_total, pol_dda_in=dda_incoming, pol_dda_out=dda_outgoing, dda_no=ddava_no,
       dda_low=ddava_low, dda_med=ddava_med, dda_high=ddava_high, dda_err=ddava_err, dda_wait=ddava_wait,
       pol_suspicious_total=suspicious_total, pol_suspicious_in=suspicious_incoming, pol_suspicious_out=suspicious_outgoing,
       pol_ccca_total=ccca_total, pol_ccca_in=ccca_incoming, pol_ccca_out=ccca_outgoing,
       pol_graymail_total=graymail_total, pol_graymail_in=graymail_incoming, pol_graymail_out=graymail_outgoing,
       graymail_mml=graymail_cat_mml, graymail_scl=graymail_cat_scl, graymail_oth=graymail_cat_oth,
       pol_analyzed_apt_total=analyzed_apt_total, pol_analyzed_apt_in=analyzed_apt_incoming, pol_analyzed_apt_out=analyzed_apt_outgoing
       where starttime = v_starttime;
       if not found then
           return -1;
       end if;
    else
       insert into tb_traffic_summary values (v_starttime, v_endtime,
       msg_cnt_total, msg_cnt_in, msg_cnt_out, msg_size_total, msg_size_in, msg_size_out,
       virus_total, virus_incoming, virus_outgoing, spy_total, spy_incoming, spy_outgoing,
       spam_total, spam_incoming, spam_outgoing, phish_total, phish_incoming, phish_outgoing,
       attach_total, attach_incoming, attach_outgoing, size_total, size_incoming, size_outgoing,
       content_total, content_incoming, content_outgoing, other_total, other_incoming, other_outgoing,
       except_total, except_incoming, except_outgoing,
       cnt_ipprof_block, cnt_ipprof_block, 0,
       cnt_nrs_block, cnt_nrs_block, 0,
       cnt_ipprof_conn, cnt_ipprof_block, cnt_virus, cnt_spam, cnt_bounce, cnt_dha, cnt_manual,
       cnt_nrs_conn, cnt_nrs_block,
       spamact_quar, spamact_del, spamact_subtag, spamact_other, spamact_total_size,
       spamact_quar_size, spamact_del_size, spamact_subtag_size, spamact_other_size,
       virusact_del, virusact_quar, virusact_clean, virusact_attdel, wrs_total, wrs_incoming, wrs_outgoing, dkim_total, dkim_incoming, dkim_outgoing,
       clean_total, clean_incoming, clean_outgoing, preflt_total, preflt_incoming, preflt_outgoing, 
       compliance_total, compliance_incoming, compliance_outgoing,
       decryption_total, encryption_total, decryption_size, encryption_size, ibe_total, ibe_incoming, ibe_outgoing,
       dda_total, dda_incoming, dda_outgoing, ddava_no, ddava_low, ddava_med, ddava_high, ddava_err, ddava_wait,
       suspicious_total, suspicious_incoming, suspicious_outgoing, ccca_total, ccca_incoming, ccca_outgoing,
       graymail_total, graymail_incoming, graymail_outgoing, graymail_cat_mml, graymail_cat_scl, graymail_cat_oth,
       analyzed_apt_total, analyzed_apt_incoming, analyzed_apt_outgoing);
       if not found then
           return -2;
       end if;
    end if;
    
    return 0;
END;
' LANGUAGE plpgsql;


---log_HourlyTableInitSP.sql
CREATE OR REPLACE FUNCTION CreateLogImportFunc (int, int) RETURNS int AS $createBody$
DECLARE
    nFirstHour     ALIAS FOR $1;
    nCreateNum     ALIAS FOR $2;
    nTmp           int;
    nHourSeq       int;
    szCreateTableCmd text;
BEGIN
    nTmp := 0;
    while nCreateNum > nTmp loop
    nHourSeq := nFirstHour + nTmp;
    szCreateTableCmd := 'CREATE OR REPLACE FUNCTION AddPolicyEventFromLog_' || nHourSeq || $AddPolicyEventFromLog1$ (
    char(36), int, varchar(321), varchar(2048), varchar(256), smallint, float,
    varchar(256), timestamptz, char(14), varchar(256), char(16), real, int, smallint, varchar(1024),
    varchar(80), varchar(1024),varchar(80), int, timestamptz, int, timestamptz, varchar(1024), bit, int, int, int, varchar(1024), varchar(256), varchar(1024), int, varchar(10), varchar(1024), varchar(1024), int, varchar(32768),int,int,int)
RETURNS integer AS $AddPolicyEventFromLog_body$
DECLARE
    v_msg_id              ALIAS FOR $1;
    v_scanner_id          ALIAS FOR $2;
    v_smtp_sender         ALIAS FOR $3;
    v_smtp_rcpt           ALIAS FOR $4;
    v_msg_subject         ALIAS FOR $5;
    v_msg_route           ALIAS FOR $6;
    v_msg_size            ALIAS FOR $7;
    v_rule_name           ALIAS FOR $8;
    v_time_date           ALIAS FOR $9;
    v_filter_types        ALIAS FOR $10;
    v_filter_description  ALIAS FOR $11;
    v_msg_actions         ALIAS FOR $12;
    v_spam_score          ALIAS FOR $13;
    v_spam_category_id    ALIAS FOR $14;
    v_spam_sensitive      ALIAS FOR $15;
    v_attach_name         ALIAS FOR $16;
    v_attach_type         ALIAS FOR $17;
    v_virus_name          ALIAS FOR $18;
    v_virus_type          ALIAS FOR $19;
    v_qa_id               ALIAS FOR $20;
    v_qa_live_ttl         ALIAS FOR $21;
    v_aa_id               ALIAS FOR $22;
    v_aa_live_ttl         ALIAS FOR $23;
    v_org_msg_id          ALIAS FOR $24;
    v_multi_virus         ALIAS FOR $25;
    v_ref_num             ALIAS FOR $26;
    v_wrs_threshold       ALIAS FOR $27;
    v_wrs_score           ALIAS FOR $28;
    v_reason              ALIAS FOR $29;
    v_dkim_author         ALIAS FOR $30;
    v_dkim_reason         ALIAS FOR $31;
    v_dda_type            ALIAS FOR $32;
    v_ccca_detection_type      ALIAS FOR $33;
    v_ccca_detection_addresses ALIAS FOR $34;
    v_wrs_category_list        ALIAS FOR $35;
    v_graymail_category        ALIAS FOR $36;
    v_dlp_detail_match_result  ALIAS FOR $37;
    v_dda_rating               ALIAS FOR $38;
    v_suspicious_apt_filters_map  ALIAS FOR $39;
    v_analyzed_apt_filters_map  ALIAS FOR $40;
        
    v_filter_type_virus         bit;
    v_filter_type_spam          bit;
    v_filter_type_attachment    bit;
    v_filter_type_content       bit;
    v_filter_type_size          bit;
    v_filter_type_other         bit;
    v_filter_type_malformed     bit;
    v_filter_type_unscanned     bit;
    v_filter_type_phishing      bit;
    v_filter_type_spyware       bit;
    v_filter_type_wrs           bit;
    v_filter_type_dkim          bit;
    v_filter_type_preflt        bit;
    v_filter_type_compliance    bit;
    v_act_deleted               bit;
    v_act_quarantined           bit;
    v_act_delivered             bit;
    v_act_archived              bit;
    v_act_rcptchanged           bit;
    v_act_stamped               bit;
    v_act_attachments_deleted   bit;
    v_act_subjects_tagged       bit;
    v_act_delivery_postponed    bit;
    v_act_notifications_sent    bit;
    v_act_cleaned               bit;
    v_act_bcc                   bit;
    v_act_handoff               bit;
    v_act_insert_x_header_tag   bit;
    v_act_decryption            bit;
    v_act_encryption            bit;
    v_act_reencryption          bit;
    v_policy_event_id           int4;
    v_len                       int;
    v_pos                       int;
    v_str                       varchar(2048);
    v_dda_status                int;
    v_filter_type_ccca          bit;
    v_filter_type_graymail      bit;
    v_filter_type_snap          bit;

BEGIN  
    /*parse to get filter type*/
    v_filter_type_virus      := substring(v_filter_types from 1 for 1);
    v_filter_type_spam       := substring(v_filter_types from 2 for 1);
    v_filter_type_attachment := substring(v_filter_types from 3 for 1);
    v_filter_type_content    := substring(v_filter_types from 4 for 1);
    v_filter_type_size       := substring(v_filter_types from 5 for 1);
    v_filter_type_other      := substring(v_filter_types from 6 for 1);
    v_filter_type_malformed  := substring(v_filter_types from 7 for 1);
    v_filter_type_unscanned  := substring(v_filter_types from 8 for 1);
    v_filter_type_phishing   := substring(v_filter_types from 9 for 1);
    v_filter_type_wrs        := substring(v_filter_types from 10 for 1);
    v_filter_type_dkim       := substring(v_filter_types from 11 for 1);
    v_filter_type_compliance := substring(v_filter_types from 13 for 1);
    v_filter_type_ccca       := substring(v_filter_types from 14 for 1);
    v_filter_type_graymail   := substring(v_filter_types from 15 for 1); 
    v_filter_type_snap       := substring(v_filter_types from 16 for 1); 
    v_filter_type_spyware    := substring(v_filter_types from 17 for 1);
    v_filter_type_preflt     := substring(v_filter_types from 18 for 1);

    /*parse to get action */
    v_act_deleted            := substring(v_msg_actions from 1 for 1);
    v_act_quarantined        := substring(v_msg_actions from 2 for 1);
    v_act_delivered          := substring(v_msg_actions from 3 for 1);
    v_act_archived           := substring(v_msg_actions from 4 for 1);
    v_act_handoff            := substring(v_msg_actions from 5 for 1); 
    v_act_rcptchanged        := substring(v_msg_actions from 6 for 1);
    v_act_stamped            := substring(v_msg_actions from 7 for 1);
    v_act_attachments_deleted:= substring(v_msg_actions from 8 for 1);
    v_act_subjects_tagged    := substring(v_msg_actions from 9 for 1);
    v_act_delivery_postponed := substring(v_msg_actions from 10 for 1);
    v_act_notifications_sent := substring(v_msg_actions from 11 for 1);
    v_act_cleaned            := substring(v_msg_actions from 12 for 1);
    v_act_bcc                := substring(v_msg_actions from 13 for 1);
    v_act_insert_x_header_tag := substring(v_msg_actions from 14 for 1);
    v_act_decryption         := substring(v_msg_actions from 15 for 1);
    v_act_encryption         := substring(v_msg_actions from 16 for 1);
    v_act_reencryption       := substring(v_msg_actions from 17 for 1);
    v_policy_event_id        := nextval('tb_policy_event_$AddPolicyEventFromLog1$ || nHourSeq || $AddPolicyEventFromLog2$_policy_event_id_seq');
    /*suspicious, suspicious + virus*/
    if v_dda_type > 0 then    
        v_dda_status := v_dda_type & 32767; /*32767=0x7FFF*/
    else
        v_dda_status := 0;
    end if;

    /*1.add a row into tb_policy_event, msg_id&scanner_id may be duplicate*/
    insert into tb_policy_event_$AddPolicyEventFromLog2$ || nHourSeq || $AddPolicyEventFromLog31$ values (v_policy_event_id,
        v_msg_id, v_scanner_id, v_smtp_sender, v_smtp_rcpt, v_msg_subject, v_msg_route, v_msg_size, v_rule_name, v_time_date, 
        v_filter_type_virus, v_filter_type_spyware, v_filter_type_spam, v_filter_type_attachment, 
        v_filter_type_content, v_filter_type_size, v_filter_type_other, v_filter_type_malformed, 
        v_filter_type_unscanned, v_filter_type_phishing, v_filter_description, v_act_deleted, v_act_quarantined,
        v_act_delivered, v_act_archived, v_act_rcptchanged, v_act_stamped, v_act_attachments_deleted, 
        v_act_subjects_tagged, v_act_delivery_postponed, v_act_notifications_sent, v_act_cleaned, v_act_bcc, 
        v_act_handoff, v_spam_score, v_spam_category_id, v_spam_sensitive, v_attach_name, v_attach_type,    
        v_virus_name, v_virus_type, v_org_msg_id, v_filter_type_wrs, v_wrs_threshold, v_wrs_score, v_reason,
        v_filter_type_dkim, v_dkim_author, v_dkim_reason, v_act_insert_x_header_tag, v_filter_type_preflt, 
        v_filter_type_compliance,v_act_decryption,v_act_encryption, v_act_reencryption, 
        v_dda_status, v_dda_rating,v_filter_type_ccca,v_ccca_detection_type,v_ccca_detection_addresses,
        v_wrs_category_list,v_filter_type_graymail,v_graymail_category,v_dlp_detail_match_result,v_filter_type_snap,
        NULL,v_suspicious_apt_filters_map,v_analyzed_apt_filters_map);
        
    if not found then
        /*could not insert tb_policy_event*/
        return -1;
    end if; 

    if v_dda_status = 100 then
        insert into tb_dtas_mail values (v_msg_id, v_scanner_id, 0, v_dda_rating, v_dda_status, '1970-01-01', 0, '1970-01-01', 0, '', '', 
            v_time_date, $AddPolicyEventFromLog31$ || nHourSeq || $AddPolicyEventFromLog3$, v_policy_event_id, v_act_quarantined::bit(1)::integer,
            v_act_archived::bit(1)::integer, v_act_delivery_postponed::bit(1)::integer, v_msg_route,'1970-01-01','1970-01-01','1970-01-01','');
    end if;

    /*2.add a row into tb_quatantine if v_act_quarantined = 1*/
    if v_act_quarantined = '1' then
        insert into tb_quarantine_$AddPolicyEventFromLog3$ || nHourSeq || $AddPolicyEventFromLog4$ (policy_event_id, 
            msg_id, scanner_id, smtp_sender, smtp_rcpt, msg_subject, msg_route, msg_size, qa_id, rule_name, time_date, 
            filter_type_virus, filter_type_spyware, filter_type_spam, filter_type_attachment,
            filter_type_content, filter_type_size, filter_type_other, filter_type_malformed,
            filter_type_unscanned, filter_type_phishing, attach_name, qt_live_ttl, ref_num, original_msg_id, 
            filter_type_wrs, filter_type_dkim, filter_type_preflt, filter_type_compliance,
            dda_status, dda_rating,filter_type_ccca, filter_type_graymail,filter_type_snap,
            suspicious_apt_filters_map,analyzed_apt_filters_map) 
            values (v_policy_event_id, v_msg_id, v_scanner_id, v_smtp_sender, v_smtp_rcpt, v_msg_subject, v_msg_route, v_msg_size,
            v_qa_id, v_rule_name, v_time_date, 
            v_filter_type_virus, v_filter_type_spyware, v_filter_type_spam, v_filter_type_attachment,
            v_filter_type_content, v_filter_type_size, v_filter_type_other, v_filter_type_malformed,
            v_filter_type_unscanned, v_filter_type_phishing, v_attach_name, v_qa_live_ttl, v_ref_num,
            v_org_msg_id, v_filter_type_wrs, v_filter_type_dkim, v_filter_type_preflt, v_filter_type_compliance,
            v_dda_status, v_dda_rating,v_filter_type_ccca,v_filter_type_graymail,
            v_filter_type_snap,v_suspicious_apt_filters_map,v_analyzed_apt_filters_map);
        
        if not found then
            /*could not insert tb_quarantine*/
            return -2;
        end if;
    end if;
    
    /*3.add a row into tb_archive if v_act_archived = 1*/
    if v_act_archived = '1' then
        insert into tb_archive_$AddPolicyEventFromLog4$ || nHourSeq || $AddPolicyEventFromLog5$ (policy_event_id, 
            msg_id, scanner_id, smtp_sender, smtp_rcpt, msg_subject, msg_route, msg_size, qa_id, rule_name, time_date, 
            filter_type_virus, filter_type_spyware, filter_type_spam, filter_type_attachment,
            filter_type_content, filter_type_size, filter_type_other, filter_type_malformed,
            filter_type_unscanned, filter_type_phishing, attach_name, qt_live_ttl, original_msg_id, filter_type_wrs, filter_type_dkim, 
            filter_type_preflt, filter_type_compliance,
            dda_status, dda_rating,filter_type_ccca, filter_type_graymail,filter_type_snap,
            suspicious_apt_filters_map,analyzed_apt_filters_map)
            values (v_policy_event_id, v_msg_id, v_scanner_id, v_smtp_sender, v_smtp_rcpt, v_msg_subject, v_msg_route, v_msg_size,
            v_aa_id, v_rule_name, v_time_date, 
            v_filter_type_virus, v_filter_type_spyware, v_filter_type_spam, v_filter_type_attachment,
            v_filter_type_content, v_filter_type_size, v_filter_type_other, v_filter_type_malformed,
            v_filter_type_unscanned, v_filter_type_phishing, v_attach_name, v_aa_live_ttl,
            v_org_msg_id, v_filter_type_wrs, v_filter_type_dkim, v_filter_type_preflt, v_filter_type_compliance, v_dda_status, v_dda_rating,
            v_filter_type_ccca,v_filter_type_graymail,v_filter_type_snap,v_suspicious_apt_filters_map,v_analyzed_apt_filters_map);
        if not found then
            /*could not insert tb_archive*/
            return -3;
        end if;
    end if;

    /*4.add rows into tb_splited_virus_event if v_multi_virus = 1*/
    if v_multi_virus = '1' then
        v_len := length(v_virus_name);
        v_str := substring(v_virus_name from 2 for v_len-1);
        v_pos := position(';' in v_str);
        while v_pos > 0 loop
            insert into tb_splited_virus_event (time_date, virus_name) 
                values (v_time_date, substring(v_str from 1 for (v_pos - 1)));
            v_str := substring(v_str from v_pos + 1 for v_len - v_pos);
            v_len := length(v_str);
            v_pos := position(';' in v_str);
        end loop;
        if trim(both from v_str) <> '' then
            insert into tb_splited_virus_event (time_date, virus_name) values (v_time_date, v_str);
        end if;
    end if;
    
    /*5.add a row into tb_postpone if v_act_delivery_postponed = 1*/
      if v_act_delivery_postponed = '1' then
            insert into tb_postpone values (v_msg_id, v_scanner_id, v_qa_id, v_smtp_sender, v_smtp_rcpt, 
                v_msg_subject, v_msg_route, v_msg_size, v_rule_name, v_time_date, 
                v_filter_type_virus, v_filter_type_spyware, v_filter_type_spam, v_filter_type_attachment,
                v_filter_type_content, v_filter_type_size, v_filter_type_other, v_filter_type_malformed,
                v_filter_type_unscanned, v_filter_type_phishing, v_attach_name, v_qa_live_ttl, v_ref_num,
                v_filter_type_wrs, v_filter_type_dkim, v_filter_type_compliance, v_dda_status, 
                v_dda_rating, v_filter_type_ccca, v_filter_type_graymail,v_filter_type_snap,
                v_suspicious_apt_filters_map,v_analyzed_apt_filters_map);
            if not found then
                /*could not insert tb_postpone*/
                return -6;
            end if;    
      end if;


    return 0;
END;
$AddPolicyEventFromLog_body$ LANGUAGE 'plpgsql';$AddPolicyEventFromLog5$ ;
    EXECUTE szCreateTableCmd;
    szCreateTableCmd := $InsertTransac0$CREATE OR REPLACE FUNCTION InsertTransac_$InsertTransac0$ || nHourSeq || $InsertTransac1$(
    in_timestamp text, scan_timestamp text, out_timestamp text, msg_id text, internal_msg_id text, postfix_id text, 
    scanner_id integer, smtp_mail_from text, smtp_rcpt_to text, subject text, client_ip text, 
    delivery_ip text, delivery_feedback text, delivery_status text, act_set text, split_flag integer, 
    extra_item text, todeliverytimestamp text, indeliverytimestamp text, dkim_result text, tls integer)
RETURNS integer AS $InsertTransacBody$
DECLARE
    v_act_deleted               bit := 0;
    v_act_quarantined           bit := 0;
    v_act_delivered             bit := 0;
    v_act_archived              bit := 0;
    v_act_rcptchanged           bit := 0;
    v_act_stamped               bit := 0;
    v_act_attachments_deleted   bit := 0;
    v_act_subjects_tagged       bit := 0;
    v_act_delivery_postponed    bit := 0;
    v_act_notifications_sent    bit := 0;
    v_act_cleaned               bit := 0;
    v_act_bcc                   bit := 0;
    v_act_handoff               bit := 0;
    v_act_insert_x_header_tag   bit := 0;
    v_act_decryption            bit := 0;
    v_act_encryption            bit := 0;
    v_act_reencryption          bit := 0;
    v_msg_tracing_id            INTEGER;
    v_match_policy_flag         BOOLEAN := False;
    v_first_delivery_timestamp  TIMESTAMPTZ := Null;
    v_first_delivery_info       TEXT := Null;
    v_TimeStamp                 TIMESTAMPTZ;
    v_in_timestamp              TEXT := Null;
    v_indeliverytimestamp       TEXT := Null;
    v_HourNum INTEGER;
    v_TableID INTEGER;
    szExecuteCmd text := Null;
    curs refcursor;
    v_client_ip text := Null;
BEGIN
    /*parse to get action */
    if act_set is not Null then
        v_act_deleted            := substring(act_set from 1 for 1);
        v_act_quarantined        := substring(act_set from 2 for 1);
        v_act_delivered          := substring(act_set from 3 for 1);
        v_act_archived           := substring(act_set from 4 for 1);
        v_act_handoff            := substring(act_set from 5 for 1); 
        v_act_rcptchanged        := substring(act_set from 6 for 1);
        v_act_stamped            := substring(act_set from 7 for 1);
        v_act_attachments_deleted:= substring(act_set from 8 for 1);
        v_act_subjects_tagged    := substring(act_set from 9 for 1);
        v_act_delivery_postponed := substring(act_set from 10 for 1);
        v_act_notifications_sent := substring(act_set from 11 for 1);
        v_act_cleaned            := substring(act_set from 12 for 1);
        v_act_bcc                := substring(act_set from 13 for 1);
        v_act_insert_x_header_tag := substring(act_set from 14 for 1);
        v_act_decryption         := substring(act_set from 15 for 1);
        v_act_encryption         := substring(act_set from 16 for 1);
        v_act_reencryption       := substring(act_set from 17 for 1);
        if act_set != '00000000000000000' then
            v_match_policy_flag = True;
        end if;
    end if;
    
      
    if delivery_status = 'deferred' then
        v_first_delivery_timestamp = todeliverytimestamp::TIMESTAMPTZ;
        v_first_delivery_info = delivery_feedback;
    end if;
  
    if (client_ip is null) and (out_timestamp is not Null) and (msg_id is not Null) then
        v_TimeStamp := date_trunc('hour', in_timestamp::TIMESTAMPTZ);
        LOOP
            v_HourNum := (floor(extract(epoch from v_TimeStamp)/3600))::INTEGER % 10000;  
            if (in_timestamp::TIMESTAMPTZ - v_TimeStamp) > INTERVAL'2 hours' then
                EXIT;
            end if;
            RAISE INFO 'v_HourNum:%, v_TimeStamp:%', v_HourNum, v_TimeStamp;    
            v_TimeStamp := v_TimeStamp - INTERVAL'1 hour';
            SELECT INTO v_TableID table_id FROM tb_log_table_info WHERE hour_num = v_HourNum;
            if not found then
                RAISE INFO 'Could not get table_id from tb_log_table_info for timestamp %', v_TimeStamp;
            else
                szExecuteCmd := 'SELECT in_timestamp, client_ip, indeliverytimestamp FROM tb_msg_tracing_' || v_TableID
                                || ' WHERE msg_id = ' || quote_literal(msg_id) 
                                || ' and scan_timestamp is null and delivery_status = ''deferred'';';
                OPEN curs FOR EXECUTE szExecuteCmd;
                FETCH curs INTO v_in_timestamp, v_client_ip, v_indeliverytimestamp;
                if v_in_timestamp is not Null then
                    CLOSE curs;
                    EXIT;   --EXIT the loop when found the record
                end if;
                CLOSE curs;
            end if;
        END LOOP; 
        if v_in_timestamp is not Null and v_client_ip is not Null then     
            --Find the firs the record
            v_TimeStamp := date_trunc('hour', v_in_timestamp::TIMESTAMPTZ);
            v_HourNum := (floor(extract(epoch from v_TimeStamp)/3600))::INTEGER % 10000;  
            SELECT INTO v_TableID table_id FROM tb_log_table_info WHERE hour_num = v_HourNum;
            if not found then
                RAISE INFO 'Could not get table_id from tb_log_table_info for timestamp %', v_TimeStamp;
            else
                szExecuteCmd := 'SELECT InsertTransac_' || v_TableID || '(' 
                                || COALESCE(quote_literal(v_in_timestamp),'null') || ','
                                || COALESCE(quote_literal(scan_timestamp),'null') || ','
                                || COALESCE(quote_literal(out_timestamp),'null') || ','
                                || COALESCE(quote_literal(msg_id),'null') ||','
                                || COALESCE(quote_literal(internal_msg_id),'null') || ','
                                || COALESCE(quote_literal(postfix_id),'null') ||','
                                || quote_literal(scanner_id) || ','
                                || COALESCE(quote_literal(smtp_mail_from),'null') ||','
                                || COALESCE(quote_literal(smtp_rcpt_to),'null') || ','
                                || COALESCE(quote_literal(subject),'null') || ','
                                || COALESCE(quote_literal(v_client_ip),'null') || ','
                                || COALESCE(quote_literal(delivery_ip),'null') || ','
                                || COALESCE(quote_literal(delivery_feedback),'null') || ','
                                || COALESCE(quote_literal(delivery_status),'null') || ','
                                || COALESCE(quote_literal(act_set),'null') || ','
                                || quote_literal(split_flag) || ','
                                || COALESCE(quote_literal(extra_item),'null') || ','
                                || COALESCE(quote_literal(todeliverytimestamp),'null') || ','
                                || COALESCE(quote_literal(v_indeliverytimestamp),'null') || ','
                                || COALESCE(quote_literal(dkim_result),'null') || ','
                                || quote_literal(tls) || ');';
                EXECUTE szExecuteCmd;
                if not found then
                    RAISE INFO 'select InsertTransac_% failed. szExecuteCmd = %', v_TableID, szExecuteCmd;
                    return -1;
                end if;    
                return 0;             
            end if;             
        else
            RAISE INFO 'Cannot got the first deferred record in_timestamp %', v_in_timestamp;
        end if;
    end if;    
    
    v_msg_tracing_id := nextval('tb_msg_tracing_$InsertTransac1$ || nHourSeq || $InsertTransac2$_msg_tracing_id_seq');        
    INSERT INTO tb_msg_tracing_$InsertTransac2$ || nHourSeq || $InsertTransac3$ VALUES (v_msg_tracing_id, 
                                        in_timestamp::timestamptz, 
                                        scan_timestamp::timestamptz, 
                                        out_timestamp::timestamptz,
                                        v_first_delivery_timestamp,
                                        msg_id,
                                        internal_msg_id, 
                                        postfix_id,
                                        scanner_id,
                                        smtp_mail_from,
                                        smtp_rcpt_to,
                                        subject,
                                        client_ip,
                                        delivery_ip,
                                        delivery_feedback,
                                        delivery_status,
                                        v_first_delivery_info,
                                        v_act_deleted,
                                        v_act_quarantined,
                                        v_act_delivered,
                                        v_act_archived,
                                        v_act_rcptchanged,
                                        v_act_stamped,
                                        v_act_attachments_deleted,
                                        v_act_subjects_tagged,
                                        v_act_delivery_postponed,
                                        v_act_notifications_sent,
                                        v_act_cleaned,
                                        v_act_bcc,
                                        v_act_handoff,
                                        v_act_insert_x_header_tag,
                                        extra_item,
                                        split_flag,
                                        False,
                                        v_match_policy_flag,
                                        todeliverytimestamp::timestamptz, 
                                        indeliverytimestamp::timestamptz,
                                        v_act_decryption,
                                        v_act_encryption,
                                        v_act_reencryption,
                                        dkim_result,
                                        tls);
    if not found then
        /*could not insert tb_msg_tracing*/
        return -1;
    else
        return v_msg_tracing_id;
    end if;                                          
END;
$InsertTransacBody$
LANGUAGE $sql$plpgsql$sql$;$InsertTransac3$;
    EXECUTE szCreateTableCmd;

    nTmp := nTmp + 1;
    end loop;

    return 0;
END;
$createBody$ LANGUAGE plpgsql;

select CreateLogImportFunc(0, 1536);

---drop function getNextHourlyTableID
DROP FUNCTION getNextHourlyTableID (int,int);

---rollback rt_GenMailTrafficSP.sql 
CREATE OR REPLACE FUNCTION GenMailTraffic_Policy(int, timestamptz, timestamptz, int) RETURNS SETOF RECORD AS '
DECLARE
    cnt        INTEGER;
    view        RECORD;
    rec_count    RECORD;
    starttable     INTEGER;
    endtable    INTEGER;
    szCmd         text;
    scanner_id    ALIAS FOR $1;
    starttime     ALIAS FOR $2;
    endtime        ALIAS FOR $3;
    risklevel   ALIAS FOR $4;
BEGIN
    select into starttable * from (select lt.table_id from tb_log_table_info lt where lt.time_start <= starttime and lt.time_end > starttime and lt.hour_num <> -1) foo;
    if found then
    
    /* Total mail */
        szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.dda_status<>100 and pe.scanner_id = '' || scanner_id || '' and pe.time_date >= '''''' || starttime || '''''' 
        and pe.time_date < '''''' || endtime || '''''' group by pe.msg_id, pe.scanner_id) foo'';
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 1;
    return next rec_count;

    /* Incoming */
        szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.dda_status<>100 and pe.scanner_id = '' || scanner_id || '' and pe.msg_route = 1 
        and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''' group by pe.msg_id, pe.scanner_id) foo'';
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 2;
    return next rec_count;
    
    /* Outgoing */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.dda_status<>100 and pe.scanner_id = '' || scanner_id || '' and pe.msg_route = 2
        and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''' group by pe.msg_id, pe.scanner_id) foo'';
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 3;
    return next rec_count;
    
    /* Normal */
    szCmd := ''select sum(clean) as counts from (select
        case when sum(
                     (pe.filter_type_virus|pe.filter_type_spyware|pe.filter_type_spam|pe.filter_type_phishing|pe.filter_type_wrs|pe.filter_type_dkim|pe.filter_type_attachment|pe.filter_type_size|pe.filter_type_content|pe.filter_type_other|pe.filter_type_malformed|pe.filter_type_unscanned|pe.filter_type_preflt|pe.filter_type_compliance|pe.filter_type_ccca|pe.filter_type_graymail)::integer
                     + case when pe.suspicious_apt_filters_map<>0 then 1 else 0 end
                     + case when pe.analyzed_apt_filters_map<>0 then 1 else 0 end)
                     >0 then 0 else 1 end as clean,
                     pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
                     where pe.dda_status<>100 and pe.scanner_id = '' || scanner_id || '' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''' group by pe.msg_id ) as foo'';
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 4;
    return next rec_count;
    
    /* Virus */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_virus=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo'';
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 5;
    return next rec_count;

        /* Spyware */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_spyware=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 6;
    return next rec_count;

        /* Spam */
        szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_spam=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 7;
    return next rec_count;
    
    /* Phishing */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_phishing=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 8;
    return next rec_count;
    
    /* Attachment */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_attachment=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 9;
    return next rec_count;
    
    /* Size */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_size=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 10;
    return next rec_count;
    
    /* Content */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_content=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 11;
    return next rec_count;
    
    /* Other */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_other=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 12;
    return next rec_count;
    
    /* Malformed, Unscanned */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_malformed=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_unscanned=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := cnt + view.counts;
    end loop;
       select into rec_count cnt, 13;
    return next rec_count;
    
    /* WRS */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_wrs=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 14;
    return next rec_count;
    
    /* DKIM */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_dkim=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 15;
    return next rec_count;
    
    /* PRE-FILTER */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_preflt=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 16;
    return next rec_count;
    
    /* Compliance */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_compliance=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 17;
    return next rec_count;
    
    /* Suspicious */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.suspicious_apt_filters_map<>0 and pe.dda_status<>100 and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 18;
    return next rec_count;

    /* Suspicious exploit */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.dda_status<>100 and pe.analyzed_apt_filters_map<>0 and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
    select into rec_count cnt, 19;
    return next rec_count;
    
    /* CCCA */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_ccca=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 20;
    return next rec_count;

    /* graymail */
    szCmd := ''select count(msg_id) as counts from (select pe.msg_id from tb_policy_event_'' || mod(starttable,64*24) || '' pe 
        where pe.scanner_id = '' || scanner_id || '' 
        and pe.filter_type_graymail=''''1'''' and pe.time_date >= '''''' || starttime || '''''' and pe.time_date < '''''' || endtime || '''''') foo''; 
    for view in execute szCmd loop
        cnt := view.counts;
    end loop;
       select into rec_count cnt, 21;
    return next rec_count;

    end if;
END;
' LANGUAGE plpgsql;


-- script ends here
------------------------------------------------------------

COMMIT;
