---using transaction to protect current database
BEGIN;

--Update changed 
-- Update dlp_expression 00000000-0000-0000-0001-000000000003 All: Credit Card Number
delete from tb_dlp_expression where name='00000000-0000-0000-0001-000000000003';
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000003','All: Credit Card Number','Credit card numbers','1','0123456789-.',15, 19, '', 0, 0, 0, '', 0, 0, 0, '[^\\d-](\\d{15,16}|\\d{4}[-. ]\\d{4}[-. ]\\d{4}[-. ]\\d{4}|\\d{4}[-. ]\\d{6}[-. ]\\d{5})[^\\d-]', '', 'nnnn-nnnn-nnnn-nnnn OR nnnnnnnnnnnnnnnn OR nnnnnnnnnnnnnnn OR nnnn-nnnnnn-nnnnn, etc.', 'CreditCardNumber', false, true, current_timestamp, '<entity caseSensitive="false" description="Credit card numbers" display_name="All: Credit Card Number" maxLength="19" minLength="15" name="00000000-0000-0000-0001-000000000003" pre-defined="true" type="Type 1" validator="CreditCardNumber"><regularExpression>[^\\d-](\\d{15,16}|\\d{4}[-. ]\\d{4}[-. ]\\d{4}[-. ]\\d{4}|\\d{4}[-. ]\\d{6}[-. ]\\d{5})[^\\d-]</regularExpression><alphabetCharset>0123456789-.</alphabetCharset><patternForDisplay>nnnn-nnnn-nnnn-nnnn OR nnnnnnnnnnnnnnnn OR nnnnnnnnnnnnnnn OR nnnn-nnnnnn-nnnnn, etc.</patternForDisplay><examples /></entity>'  );

-- Update dlp_expression  '00000000-0000-0000-0001-000000000131','China: Bank Account Number'
delete from tb_dlp_expression where name='00000000-0000-0000-0001-000000000131';
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000131','China: Bank Account Number','Used to identify the bank account of an individual or organization in China','1','0123456789',15, 19, '', 0, 0, 0, '', 0, 0, 0, '[^\\d]((10|18|35|37|4\\d|5\\d|60|61|62|65|68|69|84|87|88|95|98)(\\d{13,17}))[^\\d]', '', '', 'ChinaBankAccount', false, true, current_timestamp, '<entity caseSensitive="false" description="Used to identify the bank account of an individual or organization in China" display_name="China: Bank Account Number" maxLength="19" minLength="15" name="00000000-0000-0000-0001-000000000131" pre-defined="true" type="Type 1" validator="ChinaBankAccount"><regularExpression>[^\\d]((10|18|35|37|4\\d|5\\d|60|61|62|65|68|69|84|87|88|95|98)(\\d{13,17}))[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay /><examples /></entity>'  );

-- Add new templates/expressions.
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000159','China: Phone Number','Phone number used in China','1','0123456789-+()',11, 16, '', 0, 0, 0, '', 0, 0, 0, '[^\\d]((\\+86(\\-|\\s)?)?(\\d{2,3}(\\-|\\s)?|(\\(\\d{2,3})\\))(\\d{7,8}|\\d{3,4}(\\-|\\s)\\d{4}))[^\\d]', '010-12345678,010-123-4567,(010)12345678,+8618612345978,+86 130 12345678,+86-130-12345678', '', 'None', false, true, current_timestamp, '<entity caseSensitive="false" description="Phone number used in China" display_name="China: Phone Number" maxLength="16" minLength="11" name="00000000-0000-0000-0001-000000000159" pre-defined="true" type="Type 1" validator="None"><regularExpression>[^\\d]((\\+86(\\-|\\s)?)?(\\d{2,3}(\\-|\\s)?|(\\(\\d{2,3})\\))(\\d{7,8}|\\d{3,4}(\\-|\\s)\\d{4}))[^\\d]</regularExpression><alphabetCharset>0123456789-+()</alphabetCharset><patternForDisplay /><examples>010-12345678,010-123-4567,(010)12345678,+8618612345978,+86 130 12345678,+86-130-12345678</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000160','Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)','An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil','1','0123456789.-/',18, 18, '', 0, 0, 0, '', 0, 0, 0, '[^\\d-](\\d{2}(\\.\\d{3}){2}\\/(\\d{4}\\-\\d{2}))[^\\d-]', '12.345.678/0001-96, 96.351.249/0001-10', 'nn.nnn.nnn/nnnn-nn', 'BrazilCNPJ', false, true, current_timestamp, '<entity caseSensitive="false" description="An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil" display_name="Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)" maxLength="18" minLength="18" name="00000000-0000-0000-0001-000000000160" pre-defined="true" type="Type 1" validator="BrazilCNPJ"><regularExpression>[^\\d-](\\d{2}(\\.\\d{3}){2}\\/(\\d{4}\\-\\d{2}))[^\\d-]</regularExpression><alphabetCharset>0123456789.-/</alphabetCharset><patternForDisplay>nn.nnn.nnn/nnnn-nn</patternForDisplay><examples>12.345.678/0001-96, 96.351.249/0001-10</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000161','Spain: Full Spanish Name','Spanish name listed in "First Name" "Surname" format','0','',0, 0, '', 0, 0, 0, '', 0, 0, 0, '[^\\wÀ-Üà-ü]([A-ZÀ-Ü][a-zà-ü]{1,12}(\\sD(a|os|el|e(\\sL[ao]s?)?)|\\sSan)?\\s[A-ZÀ-Ü][a-zà-ü]{1,12}|[A-ZÀ-Ü]{2,13}(\\sD(A|OS|EL|E(\\sL[AO]S?)?)|\\sSAN)?\\s[A-ZÀ-Ü]{2,13}|[a-zà-ü]{2,13}(\\sd(a|os|el|e(\\sl[ao]s?)?)|\\ssan)?\\s[a-zà-ü]{2,13})[^\\wÀ-Üà-ü]', 'Aaron Abad', 'Fname Lname', 'SPANISHNAME', true, true, current_timestamp, '<entity caseSensitive="true" description="Spanish name listed in &quot;First Name&quot; &quot;Surname&quot; format" display_name="Spain: Full Spanish Name" name="00000000-0000-0000-0001-000000000161" pre-defined="true" type="Generic" validator="SPANISHNAME"><regularExpression>[^\\wÀ-Üà-ü]([A-ZÀ-Ü][a-zà-ü]{1,12}(\\sD(a|os|el|e(\\sL[ao]s?)?)|\\sSan)?\\s[A-ZÀ-Ü][a-zà-ü]{1,12}|[A-ZÀ-Ü]{2,13}(\\sD(A|OS|EL|E(\\sL[AO]S?)?)|\\sSAN)?\\s[A-ZÀ-Ü]{2,13}|[a-zà-ü]{2,13}(\\sd(a|os|el|e(\\sl[ao]s?)?)|\\ssan)?\\s[a-zà-ü]{2,13})[^\\wÀ-Üà-ü]</regularExpression><patternForDisplay>Fname Lname</patternForDisplay><examples>Aaron Abad</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000162','Taiwan: Jih Sun Bank Account Number','Used to record the financial transactions between an account holder and Jih Sun Bank','0','',0, 0, '', 0, 0, 0, '', 0, 0, 0, '((\\b\\d{14}\\b)|(\\b\\d{3}-\\d{2}-\\d{6}-\\d-\\d{2}\\b)|(\\b\\d{3}-\\d{8}-\\d{3}\\b))', '00210016823800, 002-10032467-200, 10126772040000, 101-13005240-001', 'XXXXXXXXXXXXXX, XXX-XX-XXXXXX-X-XX, XXX-XXXXXXXX-XXX', 'JihsunBankAccountNumber', false, true, current_timestamp, '<entity caseSensitive="false" description="Used to record the financial transactions between an account holder and Jih Sun Bank" display_name="Taiwan: Jih Sun Bank Account Number" name="00000000-0000-0000-0001-000000000162" pre-defined="true" type="Generic" validator="JihsunBankAccountNumber"><regularExpression>((\\b\\d{14}\\b)|(\\b\\d{3}-\\d{2}-\\d{6}-\\d-\\d{2}\\b)|(\\b\\d{3}-\\d{8}-\\d{3}\\b))</regularExpression><patternForDisplay>XXXXXXXXXXXXXX, XXX-XX-XXXXXX-X-XX, XXX-XXXXXXXX-XXX</patternForDisplay><examples>00210016823800, 002-10032467-200, 10126772040000, 101-13005240-001</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000163','UK: RD&E Hospital Number','Used to identify patients of the Royal Devon & Exeter Hospital','0','',0, 0, '', 0, 0, 0, '', 0, 0, 0, '(\\b([a-zA-Z]{2}|\\d{2})\\d{5}\\b)', 'AA31237', 'AADDDDD, DDDDDD', 'RDENumber', false, true, current_timestamp, '<entity caseSensitive="false" description="Used to identify patients of the Royal Devon &amp; Exeter Hospital" display_name="UK: RD&amp;E Hospital Number" name="00000000-0000-0000-0001-000000000163" pre-defined="true" type="Generic" validator="RDENumber"><regularExpression>(\\b([a-zA-Z]{2}|\\d{2})\\d{5}\\b)</regularExpression><patternForDisplay>AADDDDD, DDDDDD</patternForDisplay><examples>AA31237</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000164','Japan: My Number - Individual Number','Social security and tax number (My Number) for individuals in Japan','1','0123456789',12, 12, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d{12})[^\\d]', '123456798955,123456798858, 123456798050', 'NNNNNNNNNNNC', 'JapanMyNumberIndividual', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for individuals in Japan" display_name="Japan: My Number - Individual Number" maxLength="12" minLength="12" name="00000000-0000-0000-0001-000000000164" pre-defined="true" type="Type 1" validator="JapanMyNumberIndividual"><regularExpression>[^\\d](\\d{12})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>NNNNNNNNNNNC</patternForDisplay><examples>123456798955,123456798858, 123456798050</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000165','Japan: My Number - Corporate Number: Registered corporations','Social security and tax number (My Number) for registered corporations established in Japan','1','0123456789',13, 13, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d{13})[^\\d]', '7123456789012, 9333333333333', 'CNNNNNNNNNNNN', 'JapanMyNumberCorporate', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for registered corporations established in Japan" display_name="Japan: My Number - Corporate Number: Registered corporations" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000165" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d{13})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>CNNNNNNNNNNNN</patternForDisplay><examples>7123456789012, 9333333333333</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000166','Japan: My Number - Corporate Number: Unregistered corporations and associations without legal personality','Social security and tax number (My Number) for unregistered corporations, incorporated associations without legal personality, and foundations without legal personality in Japan','1','0123456789',13, 13, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d7001\\d{8})[^\\d]', '5700112345678, 1700187654321', 'C7001NNNNNNNN', 'JapanMyNumberCorporate', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for unregistered corporations, incorporated associations without legal personality, and foundations without legal personality in Japan" display_name="Japan: My Number - Corporate Number: Unregistered corporations and associations without legal personality" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000166" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d7001\\d{8})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>C7001NNNNNNNN</patternForDisplay><examples>5700112345678, 1700187654321</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000167','Japan: My Number - Corporate Number: Central government organizations','Social security and tax number (My Number) for central government organizations in Japan','1','0123456789',13, 13, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d00001\\d{7})[^\\d]', '3000011234567', 'C00001NNNNNNN', 'JapanMyNumberCorporate', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for central government organizations in Japan" display_name="Japan: My Number - Corporate Number: Central government organizations" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000167" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d00001\\d{7})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>C00001NNNNNNN</patternForDisplay><examples>3000011234567</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000168','Japan: My Number - Corporate Number: Local governments with Community Identification Number','Social security and tax number (My Number) for local governments with Community Identification Number in Japan','1','0123456789',13, 13, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d00002\\d{7})[^\\d]', '1000021234567, 1000027654321', 'C00002NNNNNNN', 'JapanMyNumberCorporate', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for local governments with Community Identification Number in Japan" display_name="Japan: My Number - Corporate Number: Local governments with Community Identification Number" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000168" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d00002\\d{7})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>C00002NNNNNNN</patternForDisplay><examples>1000021234567, 1000027654321</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000169','Japan: My Number - Corporate Number: Local governments without Community Identification Number','Social security and tax number (My Number) for local governments without Community Identification Number in Japan','1','0123456789',13, 13, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d00003\\d{7})[^\\d]', '8000031234567, 1000032222222', 'C00003NNNNNNN', 'JapanMyNumberCorporate', false, true, current_timestamp, '<entity caseSensitive="false" description="Social security and tax number (My Number) for local governments without Community Identification Number in Japan" display_name="Japan: My Number - Corporate Number: Local governments without Community Identification Number" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000169" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d00003\\d{7})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>C00003NNNNNNN</patternForDisplay><examples>8000031234567, 1000032222222</examples></entity>'  );
insert into tb_dlp_expression(name, display_name, description, criteria, spec_char, spec_min, spec_max, suff_char, suff_len, suff_expr_min, suff_expr_max,sepa_char, sepa_left_min, sepa_left_max, sepa_right_max, expression, example, display_data, validator, case_sensitive, pre_define, modified, content)values('00000000-0000-0000-0001-000000000170','Taiwan: Mega Bank Account Number','Used to record the financial transactions between an account holder and Mega Bank','1','0123456789',11, 11, '', 0, 0, 0, '', 0, 0, 0, '[^\\d](\\d{11})[^\\d]', '00727060011, 00727060102', 'NNNNNNNNNNC', 'MegaBankAccountNumber', false, true, current_timestamp, '<entity caseSensitive="false" description="Used to record the financial transactions between an account holder and Mega Bank" display_name="Taiwan: Mega Bank Account Number" maxLength="11" minLength="11" name="00000000-0000-0000-0001-000000000170" pre-defined="true" type="Type 1" validator="MegaBankAccountNumber"><regularExpression>[^\\d](\\d{11})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>NNNNNNNNNNC</patternForDisplay><examples>00727060011, 00727060102</examples></entity>'  );
insert into tb_named_obj(type, name, content) values(8, 'China: Phone Number', '36:00000000-0000-0000-0004-000000000218:26:Phone number used in China:303:<template description="Phone number used in China" display_name="China: Phone Number" name="00000000-0000-0000-0004-000000000218" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000159" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000218','00000000-0000-0000-0001-000000000159','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'All File Extension', '36:00000000-0000-0000-0004-000000000219:18:All File Extension:292:<template description="All File Extension" display_name="All File Extension" name="00000000-0000-0000-0004-000000000219" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0000-000000000159" sourceType="META" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000219','00000000-0000-0000-0000-000000000159','META');
insert into tb_named_obj(type, name, content) values(8, 'Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)', '36:00000000-0000-0000-0004-000000000220:106:An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil:454:<template description="An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil" display_name="Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)" name="00000000-0000-0000-0004-000000000220" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000160" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000220','00000000-0000-0000-0001-000000000160','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Spain: Full Spanish Name', '36:00000000-0000-0000-0004-000000000221:52:Spanish name listed in "First Name" "Surname" format:354:<template description="Spanish name listed in &quot;First Name&quot; &quot;Surname&quot; format" display_name="Spain: Full Spanish Name" name="00000000-0000-0000-0004-000000000221" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000161" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000221','00000000-0000-0000-0001-000000000161','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Taiwan: Jih Sun Bank Account Number', '36:00000000-0000-0000-0004-000000000222:84:Used to record the financial transactions between an account holder and Jih Sun Bank:377:<template description="Used to record the financial transactions between an account holder and Jih Sun Bank" display_name="Taiwan: Jih Sun Bank Account Number" name="00000000-0000-0000-0004-000000000222" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000162" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000222','00000000-0000-0000-0001-000000000162','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'UK: RD&E Hospital Number', '36:00000000-0000-0000-0004-000000000223:62:Used to identify patients of the Royal Devon & Exeter Hospital:352:<template description="Used to identify patients of the Royal Devon &amp; Exeter Hospital" display_name="UK: RD&amp;E Hospital Number" name="00000000-0000-0000-0004-000000000223" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000163" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000223','00000000-0000-0000-0001-000000000163','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Individual Number and surname in Kanji (Match 10)', '36:00000000-0000-0000-0004-000000000224:100:Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji:531:<template description="Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji" display_name="Japan: My Number - Individual Number and surname in Kanji (Match 10)" name="00000000-0000-0000-0004-000000000224" pre-defined="true" severity="Medium"><matchRule><buildingBlock sourceName="00000000-0000-0000-0002-000000000019" sourceType="KEYWORD" /><buildingBlock entityHits="10" operation="AND" sourceName="00000000-0000-0000-0001-000000000164" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000224','00000000-0000-0000-0001-000000000164','ENTITY');
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000224','00000000-0000-0000-0002-000000000019','KEYWORD');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Individual Number and surname in Kanji (Match 50)', '36:00000000-0000-0000-0004-000000000225:100:Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji:531:<template description="Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji" display_name="Japan: My Number - Individual Number and surname in Kanji (Match 50)" name="00000000-0000-0000-0004-000000000225" pre-defined="true" severity="Medium"><matchRule><buildingBlock sourceName="00000000-0000-0000-0002-000000000021" sourceType="KEYWORD" /><buildingBlock entityHits="50" operation="AND" sourceName="00000000-0000-0000-0001-000000000164" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000225','00000000-0000-0000-0001-000000000164','ENTITY');
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000225','00000000-0000-0000-0002-000000000021','KEYWORD');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Individual Number and surname in Kanji (Match 100)', '36:00000000-0000-0000-0004-000000000226:100:Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji:533:<template description="Social security and tax number (My Number) for individuals in Japan and their surname typed in Kanji" display_name="Japan: My Number - Individual Number and surname in Kanji (Match 100)" name="00000000-0000-0000-0004-000000000226" pre-defined="true" severity="Medium"><matchRule><buildingBlock sourceName="00000000-0000-0000-0002-000000000020" sourceType="KEYWORD" /><buildingBlock entityHits="100" operation="AND" sourceName="00000000-0000-0000-0001-000000000164" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000226','00000000-0000-0000-0001-000000000164','ENTITY');
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000226','00000000-0000-0000-0002-000000000020','KEYWORD');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Corporate Number: Registered corporations (Match 10)', '36:00000000-0000-0000-0004-000000000227:91:Social security and tax number (My Number) for registered corporations established in Japan:421:<template description="Social security and tax number (My Number) for registered corporations established in Japan" display_name="Japan: My Number - Corporate Number: Registered corporations (Match 10)" name="00000000-0000-0000-0004-000000000227" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="10" sourceName="00000000-0000-0000-0001-000000000165" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000227','00000000-0000-0000-0001-000000000165','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Corporate Number: Unregistered corporations, incorporated associations without legal personality, and foundations without legal personality (Match 10)', '36:00000000-0000-0000-0004-000000000228:177:Social security and tax number (My Number) for unregistered corporations, incorporated associations without legal personality, and foundations without legal personality in Japan:605:<template description="Social security and tax number (My Number) for unregistered corporations, incorporated associations without legal personality, and foundations without legal personality in Japan" display_name="Japan: My Number - Corporate Number: Unregistered corporations, incorporated associations without legal personality, and foundations without legal personality (Match 10)" name="00000000-0000-0000-0004-000000000228" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="10" sourceName="00000000-0000-0000-0001-000000000166" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000228','00000000-0000-0000-0001-000000000166','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Corporate Number: Central government organizations (Match 10)', '36:00000000-0000-0000-0004-000000000229:88:Social security and tax number (My Number) for central government organizations in Japan:427:<template description="Social security and tax number (My Number) for central government organizations in Japan" display_name="Japan: My Number - Corporate Number: Central government organizations (Match 10)" name="00000000-0000-0000-0004-000000000229" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="10" sourceName="00000000-0000-0000-0001-000000000167" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000229','00000000-0000-0000-0001-000000000167','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Corporate Number: Local governments with Community Identification Number (Match 10)', '36:00000000-0000-0000-0004-000000000230:110:Social security and tax number (My Number) for local governments with Community Identification Number in Japan:471:<template description="Social security and tax number (My Number) for local governments with Community Identification Number in Japan" display_name="Japan: My Number - Corporate Number: Local governments with Community Identification Number (Match 10)" name="00000000-0000-0000-0004-000000000230" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="10" sourceName="00000000-0000-0000-0001-000000000168" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000230','00000000-0000-0000-0001-000000000168','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Japan: My Number - Corporate Number: Local governments without Community Identification Number (Match 10)', '36:00000000-0000-0000-0004-000000000231:113:Social security and tax number (My Number) for local governments without Community Identification Number in Japan:477:<template description="Social security and tax number (My Number) for local governments without Community Identification Number in Japan" display_name="Japan: My Number - Corporate Number: Local governments without Community Identification Number (Match 10)" name="00000000-0000-0000-0004-000000000231" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="10" sourceName="00000000-0000-0000-0001-000000000169" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000231','00000000-0000-0000-0001-000000000169','ENTITY');
insert into tb_named_obj(type, name, content) values(8, 'Taiwan: Mega Bank Account Number', '36:00000000-0000-0000-0004-000000000232:81:Used to record the financial transactions between an account holder and Mega Bank:371:<template description="Used to record the financial transactions between an account holder and Mega Bank" display_name="Taiwan: Mega Bank Account Number" name="00000000-0000-0000-0004-000000000232" pre-defined="true" severity="Medium"><matchRule><buildingBlock entityHits="1" sourceName="00000000-0000-0000-0001-000000000170" sourceType="ENTITY" /></matchRule></template>:1:1:19:'||to_char(current_timestamp, 'YYYY-MM-DD HH24:MI:SS'));
insert into tb_dlp_template_data_reference(template_name, data_identifier_name, type) values('00000000-0000-0000-0004-000000000232','00000000-0000-0000-0001-000000000170','ENTITY');
insert into tb_dlp_validator(name, display_name) values('ChinaBankAccount','China: Bank Account Number');
insert into tb_dlp_validator(name, display_name) values('BrazilCNPJ','Brazil: National Registry of Legal Entities');
insert into tb_dlp_validator(name, display_name) values('SPANISHNAME','Spain: Full Spanish Name');
insert into tb_dlp_validator(name, display_name) values('JihsunBankAccountNumber','Taiwan: Jih Sun Bank Account Number');
insert into tb_dlp_validator(name, display_name) values('RDENumber','UK: RD&E Hospital Number');
insert into tb_dlp_validator(name, display_name) values('JapanMyNumberIndividual','Japan: My Number - Individual Number');
insert into tb_dlp_validator(name, display_name) values('JapanMyNumberCorporate','Japan: My Number - Corporate Number');
insert into tb_dlp_validator(name, display_name) values('MegaBankAccountNumber','Taiwan: Mega Bank Account Number');
-- 7z already included in GM build
--insert into tb_dlp_support_file_attribute(category , category_display_name, type , type_display_name) values('Encapsulation Format','Compressed Files', 'DG_FILE_TYPE_7Z', '7-Zip (.7z)');
--Special, All File Extension
insert into tb_dlp_file_attribute(name, display_name,description,except_flag,extension,min_size,max_size,min_unit,max_unit,pre_define,modified,content) values('00000000-0000-0000-0000-000000000159','All File Extension','All File Extension',false,'*.*',0,0,'B','B',true,current_timestamp,'<fileAttribute description="All File Extension" display_name="All File Extension" name="00000000-0000-0000-0000-000000000159" pre-defined="true" timestamp="1412761026"><fileExtension exceptFlag="false"><fileType>0</fileType><extension>*.*</extension></fileExtension></fileAttribute>');

--update version in db
insert into tb_global_setting values('general','dlp_template_version','3.1.1001','imss.ini');
-- script ends here
------------------------------------------------------------

COMMIT;
