BEGIN;
---Update All: Credit Card Number
update tb_dlp_expression set display_name='All: Credit Card Number', description='Credit card numbers', criteria='1', spec_char='0123456789-.', spec_min=14, spec_max=19, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\d-](\\d{14,16}|\\d{4}[-. ]\\d{4}[-. ]\\d{4}[-. ]\\d{4}|\\d{4}[-. ]\\d{6}[-. ]\\d{5})[^\\d-]', example='', display_data='nnnn-nnnn-nnnn-nnnn OR nnnnnnnnnnnnnnnn OR nnnnnnnnnnnnnnn OR nnnn-nnnnnn-nnnnn, etc.', validator='CreditCardNumber', case_sensitive=false, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="false" description="Credit card numbers" display_name="All: Credit Card Number" maxLength="19" minLength="14" name="00000000-0000-0000-0001-000000000003" pre-defined="true" type="Type 1" validator="CreditCardNumber"><regularExpression>[^\\d-](\\d{14,16}|\\d{4}[-. ]\\d{4}[-. ]\\d{4}[-. ]\\d{4}|\\d{4}[-. ]\\d{6}[-. ]\\d{5})[^\\d-]</regularExpression><alphabetCharset>0123456789-.</alphabetCharset><patternForDisplay>nnnn-nnnn-nnnn-nnnn OR nnnnnnnnnnnnnnnn OR nnnnnnnnnnnnnnn OR nnnn-nnnnnn-nnnnn, etc.</patternForDisplay><examples /></entity>' where name='00000000-0000-0000-0001-000000000003' ;
---Update Czech Republic: International Bank Account Number
update tb_dlp_expression set display_name='Czech Republic: International Bank Account Number', description='An international standard for identifying bank accounts with minimal risk of transcription errors', criteria='0', spec_char='', spec_min=0, spec_max=0, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='\\W(CZ\\d{2}(\\s(\\d{4}\\s){4}\\d{4}|\\d{20}))\\W', example='CZ6508000000192000145399', display_data='CZnnnnnnnnnncccccccccccc OR CZnn nnnn nnnn cccc cccc cccc', validator='IBAN', case_sensitive=true, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="true" description="An international standard for identifying bank accounts with minimal risk of transcription errors" display_name="Czech Republic: International Bank Account Number" name="00000000-0000-0000-0001-000000000070" pre-defined="true" type="Generic" validator="IBAN"><regularExpression>\\W(CZ\\d{2}(\\s(\\d{4}\\s){4}\\d{4}|\\d{20}))\\W</regularExpression><alphabetCharset /><patternForDisplay>CZnnnnnnnnnncccccccccccc OR CZnn nnnn nnnn cccc cccc cccc</patternForDisplay><examples>CZ6508000000192000145399</examples></entity>' where name='00000000-0000-0000-0001-000000000070' ;

---Update Ireland: International Bank Account Number
update tb_dlp_expression set display_name='Ireland: International Bank Account Number', description='An international standard for identifying bank accounts with minimal risk of transcription errors', criteria='0', spec_char='', spec_min=0, spec_max=0, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\w](IE\\d{2}(\\s[A-Za-z0-9]{4}\\s(\\d{4}\\s){3}\\d{2}|[A-Za-z0-9]{4}\\d{14}))[^\\w]', example='IE64IRCE92050112345678', display_data='IEnnnnnnnnnnnnnnnnnnnn OR IEnn nnnn nnnn nnnn nnnn nn', validator='IBAN', case_sensitive=true, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="true" description="An international standard for identifying bank accounts with minimal risk of transcription errors" display_name="Ireland: International Bank Account Number" name="00000000-0000-0000-0001-000000000086" pre-defined="true" type="Generic" validator="IBAN"><regularExpression>[^\\w](IE\\d{2}(\\s[A-Za-z0-9]{4}\\s(\\d{4}\\s){3}\\d{2}|[A-Za-z0-9]{4}\\d{14}))[^\\w]</regularExpression><alphabetCharset /><patternForDisplay>IEnnnnnnnnnnnnnnnnnnnn OR IEnn nnnn nnnn nnnn nnnn nn</patternForDisplay><examples>IE64IRCE92050112345678</examples></entity>' where name='00000000-0000-0000-0001-000000000086' ;

---Update Australia: TFN (Tax File Number)
update tb_dlp_expression set display_name='Australia: TFN (Tax File Number)', description='Used primarily for tax purposes, but also used in transactions with government agencies and private entities; issued by the Australian Taxation Office to citizens and organizations', criteria='1', spec_char='0123456789', spec_min=8, spec_max=9, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\d](\\d{8,9})[^\\d]', example='123456782, 75356895', display_data='NNNNNNNN OR NNNNNNNNN', validator='AustraliaTFN', case_sensitive=false, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="false" description="Used primarily for tax purposes, but also used in transactions with government agencies and private entities; issued by the Australian Taxation Office to citizens and organizations" display_name="Australia: TFN (Tax File Number)" maxLength="9" minLength="8" name="00000000-0000-0000-0001-000000000127" pre-defined="true" type="Type 1" validator="AustraliaTFN"><regularExpression>[^\\d](\\d{8,9})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>NNNNNNNN OR NNNNNNNNN</patternForDisplay><examples>123456782, 75356895</examples></entity>' where name='00000000-0000-0000-0001-000000000127' ;
--Update New Zealand: IRD Number
update tb_dlp_expression set display_name='New Zealand: IRD Number', description='Used primarily for tax purposes; also used in transactions with private entities; issued by the Inland Revenue Department to citizens and resident foreign nationals', criteria='1', spec_char='0123456789', spec_min=8, spec_max=9, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\d](\\d{8,9})[^\\d]', example='136410132', display_data='NNNNNNNN OR NNNNNNNNN', validator='NewZealandIRD', case_sensitive=false, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="false" description="Used primarily for tax purposes; also used in transactions with private entities; issued by the Inland Revenue Department to citizens and resident foreign nationals" display_name="New Zealand: IRD Number" maxLength="9" minLength="8" name="00000000-0000-0000-0001-000000000129" pre-defined="true" type="Type 1" validator="NewZealandIRD"><regularExpression>[^\\d](\\d{8,9})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>NNNNNNNN OR NNNNNNNNN</patternForDisplay><examples>136410132</examples></entity>' where name='00000000-0000-0000-0001-000000000129' ;
--Update Japan: My Number - Corporate Number: Registered corporations
update tb_dlp_expression set display_name='Japan: My Number - Corporate Number: Registered corporations', description='Social security and tax number (My Number) for registered corporations established in Japan', criteria='1', spec_char='0123456789', spec_min=13, spec_max=13, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\d](\\d{1}[0-5]\\d{3}0[1-5]\\d{6})[^\\d]', example='6012301123456, 9432105543210', display_data='CNNNNNNNNNNNN', validator='JapanMyNumberCorporate', case_sensitive=false, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="false" description="Social security and tax number (My Number) for registered corporations established in Japan" display_name="Japan: My Number - Corporate Number: Registered corporations" maxLength="13" minLength="13" name="00000000-0000-0000-0001-000000000165" pre-defined="true" type="Type 1" validator="JapanMyNumberCorporate"><regularExpression>[^\\d](\\d{1}[0-5]\\d{3}0[1-5]\\d{6})[^\\d]</regularExpression><alphabetCharset>0123456789</alphabetCharset><patternForDisplay>CNNNNNNNNNNNN</patternForDisplay><examples>6012301123456, 9432105543210</examples></entity>' where name='00000000-0000-0000-0001-000000000165' ;


--update the version
update tb_global_setting set value ='3.1.1005' where name='dlp_template_version' and section='general';
COMMIT;
