BEGIN;
---Update UK: NIN (National Insurance Number)
update tb_dlp_expression set display_name='UK: NIN (National Insurance Number)', description='Used to record national insurance and tax contributions', criteria='1', spec_char='0123456789 ABCD', spec_min=9, spec_max=13, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\w]([A-CEGHJ-PR-TW-Z][A-CEGHJ-NPR-TW-Z]\\s?\\d{2}\\s?\\d{2}\\s?\\d{2}\\s?[ABCD])[^\\w]', example='AB 12 34 56 C,  AB123456C', display_data='CCddddddC OR CC dd dd dd C', validator='None', case_sensitive=true, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="true" description="Used to record national insurance and tax contributions" display_name="UK: NIN (National Insurance Number)" maxLength="13" minLength="9" name="00000000-0000-0000-0001-000000000018" pre-defined="true" type="Type 1" validator="None"><regularExpression>[^\\w]([A-CEGHJ-PR-TW-Z][A-CEGHJ-NPR-TW-Z]\\s?\\d{2}\\s?\\d{2}\\s?\\d{2}\\s?[ABCD])[^\\w]</regularExpression><alphabetCharset>0123456789 ABCD</alphabetCharset><patternForDisplay>CCddddddC OR CC dd dd dd C</patternForDisplay><examples>AB 12 34 56 C,  AB123456C</examples></entity>' where name='00000000-0000-0000-0001-000000000018' ;

---Portugal: International Bank Account Number
update tb_dlp_expression set display_name='Portugal: International Bank Account Number', description='An international standard for identifying bank accounts with minimal risk of transcription errors', criteria='0', spec_char='', spec_min=0, spec_max=0, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\w](PT50(\\s(\\d{4}\\s){5}\\d{1}|\\d{21}))[^\\w]', example='PT50000201231234567890154', display_data='PT50nnnnnnnnnnnnnnnnnnnnn OR PT50 nnnn nnnn nnnn nnnn nnnn n', validator='IBAN', case_sensitive=true, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="true" description="An international standard for identifying bank accounts with minimal risk of transcription errors" display_name="Portugal: International Bank Account Number" name="00000000-0000-0000-0001-000000000109" pre-defined="true" type="Generic" validator="IBAN"><regularExpression>[^\\w](PT50(\\s(\\d{4}\\s){5}\\d{1}|\\d{21}))[^\\w]</regularExpression><alphabetCharset /><patternForDisplay>PT50nnnnnnnnnnnnnnnnnnnnn OR PT50 nnnn nnnn nnnn nnnn nnnn n</patternForDisplay><examples>PT50000201231234567890154</examples></entity>' where name='00000000-0000-0000-0001-000000000109' ;

---Update UK:  Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)
update tb_dlp_expression set display_name='Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)', description='An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil', criteria='1', spec_char='0123456789.-/', spec_min=18, spec_max=18, suff_char='', suff_len=0, suff_expr_min=0, suff_expr_max=0,sepa_char='', sepa_left_min=0, sepa_left_max=0, sepa_right_max=0, expression='[^\\d-](\\d{2}(\\.\\d{3}){2}\\/(\\d{4}\\-\\d{2}))[^\\d-]', example='12.345.678/0001-95, 96.351.249/0001-10', display_data='nn.nnn.nnn/nnnn-nn', validator='BrazilCNPJ', case_sensitive=false, pre_define=true, modified=current_timestamp, content= '<entity caseSensitive="false" description="An identification number issued to Brazilian companies by the Secretariat of the Federal Revenue of Brazil" display_name="Brazil: CNPJ - Cadastro Nacional da Pessoa Jurídica (National Registry of Legal Entities)" maxLength="18" minLength="18" name="00000000-0000-0000-0001-000000000160" pre-defined="true" type="Type 1" validator="BrazilCNPJ"><regularExpression>[^\\d-](\\d{2}(\\.\\d{3}){2}\\/(\\d{4}\\-\\d{2}))[^\\d-]</regularExpression><alphabetCharset>0123456789.-/</alphabetCharset><patternForDisplay>nn.nnn.nnn/nnnn-nn</patternForDisplay><examples>12.345.678/0001-95, 96.351.249/0001-10</examples></entity>' where name='00000000-0000-0000-0001-000000000160' ;
--update the version
update tb_global_setting set value ='3.1.1006' where name='dlp_template_version' and section='general';
COMMIT;
